function cleanTitle(title) {
    return title
        .replace(/&#8217;/g, "'")  
        .replace(/&#8211;/g, "-")  
        .replace(/&#[0-9]+;/g, ""); 
}

async function searchResults(keyword) {
    const results = [];
    const response = await fetchv2(`https://estrenosdoramas.es/?s=${keyword}`);
    const html = await response.text();

    const regex = /<article[^>]*class="[^"]*bs[^"]*"[^>]*>.*?<a href="([^"]+)"[^>]*>.*?<div class="ttzz">\s*(.*?)\s*<\/div>.*?<img[^>]*src="([^"]+)"[^>]*>/gs;

    let match;
    while ((match = regex.exec(html)) !== null) {
        results.push({
            title: cleanTitle(match[2].trim()),
            image: match[3].trim(),
            href: match[1].trim()
        });
    }

    return JSON.stringify(results);
}


async function extractDetails(url) {
    const results = [];
    const response = await fetchv2(url);
    const html = await response.text();

    const match = html.match(/<div class="entry-content"[^>]*>([\s\S]*?)<\/div>/);

    let description = "N/A";
    if (match) {
        description = match[1]
            .replace(/<[^>]+>/g, '') 
            .replace(/&#(\d+);/g, (_, code) => String.fromCharCode(code)) 
            .replace(/&quot;/g, '"') 
            .replace(/&apos;/g, "'") 
            .replace(/&amp;/g, "&") 
            .trim();
    }

    results.push({
        description: description,
        aliases: 'N/A',
        airdate: 'N/A'
    });

    return JSON.stringify(results);
}

async function extractEpisodes(url) {
    const results = [];
    const response = await fetchv2(url);
    const html = await response.text();

    const regex = /<li[^>]*id="epcheck"[^>]*>[\s\S]*?<a href="([^"]+)">/g;

    let match;
    while ((match = regex.exec(html)) !== null) {
        results.push(match[1].trim());
    }

    const total = results.length;
    const final = results.map((href, index) => ({
        href: href,
        number: total - index
    }));

    return JSON.stringify(final.reverse());
}

async function extractStreamUrl(url) {
    try {
        const response = await fetchv2(url);
        const html = await response.text();

        const embedMatch = html.match(/<div class="pembed" data-embed="([^"]+)"/);
        if (!embedMatch) return "error";
        const embedUrl = embedMatch[1].trim();
        console.log(embedUrl);
        const headers = {
                "User-Agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.3",
                "Referer": url
        };

        const embedResponse = await fetchv2(embedUrl.replace("//", "https://"), headers);
        const embedHtml = await embedResponse.text();
        console.log(embedHtml);
        const fileMatch = embedHtml.match(/sources:\s*\[\{file:"([^"]+)"/);
        if (!fileMatch) return "error";

        return fileMatch[1];
    } catch (err) {
        console.log(err);
        return "error";
    }
}

